/*
 * graphics.c
 */

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

/*
 *
 */

#include	"status.h"
#include	"board.h"
#include	"rule.h"
#include	"comp.h"
#include	"graphics.h"

/*
 *
 */

#define	R_SIZE	20							/* R}̔a */
#define	C_SIZE	(R_SIZE*2-1)				/* R}̑傫 */
#define	S_SIZE	2							/* Ԃ̑傫 */
#define	G_SIZE	(S_SIZE*2+1)				/* R}ƃR}̊ */
#define	F_SIZE	(C_SIZE+G_SIZE)				/* ̃R}玟̃R}܂ł̒ */
#define	W_SIZE	(F_SIZE*BOARD_SIZE+G_SIZE)	/* ̃TCY */
#define	H_SIZE	(W_SIZE/2)					/* ̃TCY̔ */

#define	lPos(N)	(G_SIZE+(N)*(C_SIZE+G_SIZE)-H_SIZE)	/* R}ԍg̈ʒu */
#define	cPos(N)	(lPos(N)+S_SIZE+1+R_SIZE)			/* R}ԍR}̒̈ʒu */

/*
 *
 */

#define PART 100 // 

/*
 *	w̏ꏊɎw肵F̃R}`悷
 */
 
static void circle( int x, int y, int color ) {
  int i;
  int n = PART;
  float cx = (float) cPos(x) / H_SIZE;
  float cy = (float) cPos(y) / H_SIZE;
  float r = (float) R_SIZE / H_SIZE;
  float px;
  float py;
  double rate;

  switch ( color ) {
  case WHITE:
	  glColor3f(1.0, 1.0, 1.0); // `敨̂ɔFݒ
	  break;
  case BLACK:
	  glColor3f(0.0, 0.0, 0.0); // `敨̂ɍFݒ
	  break;
  }

  glBegin(GL_POLYGON); // |S̕`
  // ~`
  for (i = 0; i < n; i++) {
    // WvZ
    rate = (double)i / n;
    px = r * cos(2.0 * M_PI * rate) + cx;
    py = r * sin(2.0 * M_PI * rate) + cy;
    glVertex3f(px, py, 0.0); // _Ww
  }
  glEnd(); // |S̕`I

}

/*
 *	_Ԃɒ
 */
 
static void line( int px1, int py1, int px2, int py2 ) {

  glBegin(GL_LINES);
  glVertex3f(((float)px1)/H_SIZE,((float)py1)/H_SIZE,0.0);
  glVertex3f(((float)px2)/H_SIZE,((float)py2)/H_SIZE,0.0);
  glEnd();

}

/*
 *	{[h̃R}\
 */

 static void draw_board ( char board[BOARD_SIZE][BOARD_SIZE] ) {
   int x;
   int y;

   /* g` */
   glColor3f(1.0, 1.0, 1.0);
   for ( x = 0; x <= BOARD_SIZE; x++ ) {
	 line ( -H_SIZE, lPos(x), lPos(BOARD_SIZE)+H_SIZE, lPos(x) );
	 line ( lPos(x), -H_SIZE, lPos(x), lPos(BOARD_SIZE)+H_SIZE );
   }

   /* R}` */
   for ( x = 0; x < BOARD_SIZE; x++ ) {
	 for ( y = 0; y < BOARD_SIZE; y++ ) {
	   if ( board [ x ][ y ] != EMPTY ) {
		 circle ( x, BOARD_SIZE - 1 - y, board [ x ][ y ] );
	   }
	 }
   }

 }

/*
 *
 */

static char displayBoard[BOARD_SIZE][BOARD_SIZE];
static char color = BLACK;

static void display(void)
{

  glClearColor(0.0, 0.4, 0.0, 0.0);	/*  */
  glClear(GL_COLOR_BUFFER_BIT);

  //	glPushMatrix();
  //	glColor3f(1.0, 1.0, 1.0);

  draw_board ( displayBoard );

  //	glPopMatrix();
  //	glutSwapBuffers();

  glFlush();

}

/*
 *	s
 */

static void init(void)
{
	glClearColor(0.0, 0.0, 0.0, 0.0);
	glShadeModel(GL_FLAT);
}

/*
 *	{^ƌĂ΂֐
 */

static void mouse(int button, int state, int x, int y)
{
	switch (button) {
		case GLUT_LEFT_BUTTON:
			if (state == GLUT_DOWN) {
			  int px = x/F_SIZE;
			  int py = y/F_SIZE;
			  char hands[HANDS_SIZE];

			  if ( playable ( displayBoard, px, py, color ) == YES ) {
				play_hand ( displayBoard, px, py, color );
				color = get_oposit_color ( color );
				display();

				if ( comp ( hands, displayBoard, color ) == YES ) {
				  px = hands[X_HAND];
				  py = hands[Y_HAND];
				  play_hand ( displayBoard, px, py, color );
				  color = get_oposit_color ( color );
				  display();
				} else {
				  exit(-1);
				}
			  }
			}
			break;
		case GLUT_MIDDLE_BUTTON:
			break;
		case GLUT_RIGHT_BUTTON:
			break;
		default:
			break;
	}
}

/*
 *	L[{[h̃L[ƌĂ΂֐
 */

static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
  case '\033':  /* '\033'  ESC  ASCII R[h */
    exit(0);
  default:
    break;
  }
}

/*
 *	GL ̏֐
 */

void graphics_init ( int argc, char** argv )
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGBA);
//	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
	glutInitWindowSize(W_SIZE, W_SIZE);
	glutInitWindowPosition(100, 100);
	glutCreateWindow(argv[0]);
	init();
	glutDisplayFunc(display);
//	glutReshapeFunc(reshape);
	glutMouseFunc(mouse);
	glutKeyboardFunc(keyboard);
	glutMainLoop();
}

/*
 *
 */

void update_graphic_board ( char board[BOARD_SIZE][BOARD_SIZE] ) {
  int x;
  int y;

  for ( x = 0; x < BOARD_SIZE; x++ ) {
	  for ( y = 0; y < BOARD_SIZE; y++ ) {
		displayBoard[x][y] = board[x][y];
	  }
  }

}

/*
 *
 */

